# -*- coding: utf-8 -*-

from qt import *
from MainForm import FormGrille


class FormGrille_Impl(FormGrille):
    
    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        FormGrille.__init__(self,parent,name,modal,fl)

    def __del__(self):
        self._sudoku.stop()
        if not self._sudoku.finished(): self._sudoku.wait()
    
    def customEvent(self, event):
        if event.type()==10000:           #boîte de dialogue
            s = event.data()
            QMessageBox.information(self,u"Solution",s)
            self.pushButtonFind.setEnabled(1)
        elif event.type()==10010:       #solution à afficher
            solution = eval(event.data())
            for i in range(81):
                a=getattr(self, "lineEdit%d" % i)
                a.setText(`solution[i]`)            
    
    def findSlot(self):
        "Chercher une solution de la grille actuelle et l'afficher dans la grille"
        self.pushButtonFind.setEnabled(0)
        self._sudoku=cSudoku(self)
        self._sudoku.start()

    def newSlot(self):
        "Effacer complètement la grille"
        for i in range(81):
            a=getattr(self, "lineEdit%d" % i)
            a.setText('')


class cSudoku(QThread):
#class cSudoku:
    "Données et fonctions pour chercher la solution au SuDoku"
    def __init__(self, parent):
        QThread.__init__(self)
        self._grille=[]
        self._grilleTemp=[]
        self._parent=parent
        for i in range(81):
            self._grille.append(0)
            a=getattr(parent, "lineEdit%d" % i)
            if a.text():self._grille[i]=int(a.text().ascii())
        self._stopped = 0

    def _lig(self,x):
        "Retourne la liste des nombres déjà présents dans la lig x"
        i=x/9
        liste=[]
        for j in range(9):
            val=self._grilleTemp[9*i+j]
            if val: liste.append(val)
        return liste
    
    def _col(self,x):
        "Retourne la liste des nombres déjà présents dans la col x"
        i=x%9
        liste=[]
        for j in range(9):
            val=self._grilleTemp[i+j*9]
            if val: liste.append(val)
        return liste
        
    def _box(self,x):
        "Retourne la liste des nombres déjà présents dans la box x"
        i=(x/27)*27+((x%27)/3%3)*3
        liste=[]
        for j in range(3):
            for k in range(3):
                val=self._grilleTemp[i+j*9+k]
                if val: liste.append(val)
        return liste
    
    def _valMinSup(self, valeursPresentes, valMin):
        """
Retourne la première valeur possible supérieure à valMin
    
valeursPresentes : liste de toutes les valeurs déjà présentes
valMin : la valeur minimale à retourner
        """
        #supprime les doublons
        d = {}
        for x in valeursPresentes: d[x]=x
        valeursPresentes = d.values()

        valeursPossibles=range(1,10)
        for valeurPresente in valeursPresentes:
            valeursPossibles.remove(valeurPresente)

        for valeurPossible in valeursPossibles:
            if valeurPossible>valMin:
                return valeurPossible
        return 0
    
    def run(self):
        "Retourne la solution de grille si elle exite, sinon []"
        self._grilleTemp=self._grille[:]
        i=0
        cptTests=0
        while not  self._stopped:
            if self._grille[i]==0:
                newVal=self._valMinSup(self._lig(i)+self._col(i)+self._box(i), self._grilleTemp[i])
                cptTests+=1
                if newVal:
                    self._grilleTemp[i]=newVal
                    i+=1
                else:
                    self._grilleTemp[i]=0
                    while 1:
                        i-=1
                        if i<0 or self._grille[i]==0: break
            else:
                i+=1
            if i<0: 
                event=QCustomEvent(10000)
                event.setData(u"PAS DE SOLUTION")
                QThread.postEvent(self._parent, event)
                break
            if i>80: 
                event=QCustomEvent(10000)
                event.setData(u"Solution trouvée après %d tests." % cptTests)
                QThread.postEvent(self._parent, event)
                event=QCustomEvent(10010)
                event.setData(`self._grilleTemp`)
                QThread.postEvent(self._parent, event)
                break

    def stop(self):
        self._stopped=1
